package de._82grfl1bif.KPI_Visualizer.structures;

import de._82grfl1bif.KPI_Visualizer.data.Klasse;
import org.bukkit.Material;

import java.awt.Point;

public class Building extends Structure{
    private final int height;
    public Klasse klasse = null;

    @Deprecated
    public Building(int width, int height, Material material){ //Buildings are Square -> no depth
        this.width.x = width;
        this.width.y = width;
        this.height = height;
        this.material = material;
        if(this.width.x < 5){
            throw new IllegalArgumentException("keine Gebäude kleiner 5 wegen 2 Gehweg");
        }
    }

    public Building(Point width/*and depth for complex algorithms*/, int height, Material material){
        this.width = width;
        this.height = height;
        this.material = material;
        if(this.width.x < 5 || this.width.y < 5){
            throw new IllegalArgumentException("keine Gebäude kleiner 5 wegen 2 Gehweg");
        }
    }

    public Building(Material material, Klasse klasse, String name){ //Buildings are Square -> no depth
        this.klasse = klasse;
        this.material = material;
        this.width = new Point((int)Math.round((klasse.variables+5)),(int)Math.round((klasse.variables+5))); //TODO: make this work with treemap and square
        this.area = klasse.variables*25;
        this.name = name;
        this.height = klasse.functions;
        if(this.width.x < 5 || this.width.y < 5){
            throw new IllegalArgumentException("keine Gebäude kleiner 5 wegen 2 Gehweg");
        }
    }

    public int getHeight() {
        return this.height;
    }

    @Override
    public Structure getFromTree(String checkName) {
        if(this.name.equals(checkName))return this;
        return null;
    }
}
